PathFileComparator (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io.comparator

## Class PathFileComparator

- java.lang.Object
- - org.apache.commons.io.comparator.AbstractFileComparator
  - - org.apache.commons.io.comparator.PathFileComparator

- All Implemented Interfaces:
    java.io.Serializable, java.util.Comparator<java.io.File>

      public class PathFileComparator
      extends AbstractFileComparator
      implements java.io.Serializable

  Compare the path of two files for order (see `File.getPath()`).

  This comparator can be used to sort lists or arrays of files by their path either in a case-sensitive, case-insensitive or system dependent case sensitive way. A number of singleton instances are provided for the various case sensitivity options (using `IOCase`) and the reverse of those options.

  Example of a case-sensitive file path sort using the `PATH_COMPARATOR` singleton instance:

             List<File> list = ...
             ((AbstractFileComparator) PathFileComparator.PATH_COMPARATOR).sort(list);

  Example of a reverse case-insensitive file path sort using the `PATH_INSENSITIVE_REVERSE` singleton instance:

             File[] array = ...
             ((AbstractFileComparator) PathFileComparator.PATH_INSENSITIVE_REVERSE).sort(array);

  Since:
    1.4
  Version:
    $Id: PathFileComparator.java 1642757 2014-12-01 21:09:30Z sebb $
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private IOCase` | `caseSensitivity` Whether the comparison is case sensitive.
    `static java.util.Comparator<java.io.File>` | `PATH_COMPARATOR` Case-sensitive path comparator instance (see `IOCase.SENSITIVE`)
    `static java.util.Comparator<java.io.File>` | `PATH_INSENSITIVE_COMPARATOR` Case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)
    `static java.util.Comparator<java.io.File>` | `PATH_INSENSITIVE_REVERSE` Reverse case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)
    `static java.util.Comparator<java.io.File>` | `PATH_REVERSE` Reverse case-sensitive path comparator instance (see `IOCase.SENSITIVE`)
    `static java.util.Comparator<java.io.File>` | `PATH_SYSTEM_COMPARATOR` System sensitive path comparator instance (see `IOCase.SYSTEM`)
    `static java.util.Comparator<java.io.File>` | `PATH_SYSTEM_REVERSE` Reverse system sensitive path comparator instance (see `IOCase.SYSTEM`)
    `private static long` | `serialVersionUID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PathFileComparator()` Construct a case sensitive file path comparator instance.
    `PathFileComparator(IOCase caseSensitivity)` Construct a file path comparator instance with the specified case-sensitivity.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(java.io.File file1, java.io.File file2)` Compare the paths of two files the specified case sensitivity.
    `java.lang.String` | `toString()` String representation of this file comparator.

    - ### Methods inherited from class org.apache.commons.io.comparator.AbstractFileComparator

      `sort, sort`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `equals`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      See Also:
        Constant Field Values

    - #### PATH_COMPARATOR

          public static final java.util.Comparator<java.io.File> PATH_COMPARATOR

      Case-sensitive path comparator instance (see `IOCase.SENSITIVE`)

    - #### PATH_REVERSE

          public static final java.util.Comparator<java.io.File> PATH_REVERSE

      Reverse case-sensitive path comparator instance (see `IOCase.SENSITIVE`)

    - #### PATH_INSENSITIVE_COMPARATOR

          public static final java.util.Comparator<java.io.File> PATH_INSENSITIVE_COMPARATOR

      Case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)

    - #### PATH_INSENSITIVE_REVERSE

          public static final java.util.Comparator<java.io.File> PATH_INSENSITIVE_REVERSE

      Reverse case-insensitive path comparator instance (see `IOCase.INSENSITIVE`)

    - #### PATH_SYSTEM_COMPARATOR

          public static final java.util.Comparator<java.io.File> PATH_SYSTEM_COMPARATOR

      System sensitive path comparator instance (see `IOCase.SYSTEM`)

    - #### PATH_SYSTEM_REVERSE

          public static final java.util.Comparator<java.io.File> PATH_SYSTEM_REVERSE

      Reverse system sensitive path comparator instance (see `IOCase.SYSTEM`)

    - #### caseSensitivity

          private final IOCase caseSensitivity

      Whether the comparison is case sensitive.

  - ### Constructor Detail

    - #### PathFileComparator

          public PathFileComparator()

      Construct a case sensitive file path comparator instance.

    - #### PathFileComparator

          public PathFileComparator(IOCase caseSensitivity)

      Construct a file path comparator instance with the specified case-sensitivity.
      Parameters:
        `caseSensitivity` - how to handle case sensitivity, null means case-sensitive

  - ### Method Detail

    - #### compare

          public int compare(java.io.File file1,
                    java.io.File file2)

      Compare the paths of two files the specified case sensitivity.
      Specified by:
        `compare` in interface `java.util.Comparator<java.io.File>`
      Parameters:
        `file1` - The first file to compare
        `file2` - The second file to compare
      Returns:
        a negative value if the first file's path is less than the second, zero if the paths are the same and a positive value if the first files path is greater than the second file.

    - #### toString

          public java.lang.String toString()

      String representation of this file comparator.
      Overrides:
        `toString` in class `AbstractFileComparator`
      Returns:
        String representation of this file comparator

Copyright (c) 2002-2016 Apache Software Foundation